import { CanActivate, ExecutionContext, Logger } from '@nestjs/common';
import { KeycloakService } from '../service';
import { Reflector } from '@nestjs/core';
import { RoleDecoratorOption } from '../decorators/roles.decorator';
import KeycloakConnect from 'keycloak-connect';
export declare class RoleGuard implements CanActivate {
    private keycloak;
    private readonly reflector;
    logger: Logger;
    constructor(keycloak: KeycloakService, reflector: Reflector);
    canActivate(context: ExecutionContext): Promise<boolean>;
    isAccessGranted(roleDefinition: RoleDecoratorOption, accessToken?: KeycloakConnect.Token): boolean;
}
//# sourceMappingURL=role.guard.d.ts.map