"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionManager = void 0;
const request_manager_1 = require("./request-manager");
class PermissionManager {
    constructor(client, endpoint) {
        this.requestManager = new request_manager_1.RequestManager(client, endpoint);
    }
    async requestTicket(ticket) {
        if (!ticket.grant_type) {
            ticket.grant_type = 'urn:ietf:params:oauth:grant-type:uma-ticket';
        }
        const params = new URLSearchParams();
        params.append('grant_type', ticket.grant_type);
        params.append('audience', ticket.audience);
        params.append('response_mode', ticket.response_mode || 'decision');
        const permission = ticket.resourceId && ticket.scope ? `${ticket.resourceId}#${ticket.scope}` : null;
        if (permission) {
            params.append('permission', permission);
        }
        const { data } = await this.requestManager.post(`/`, params, {
            headers: {
                authorization: `Bearer ${ticket.token}`,
            },
        });
        return data;
    }
}
exports.PermissionManager = PermissionManager;
//# sourceMappingURL=permission-manager.js.map