import AdminClient from '@keycloak/keycloak-admin-client';
import { TokenSet } from 'openid-client';
import { ResourceManager } from './lib/resource-manager';
import { PermissionManager } from './lib/permission-manager';
import { KeycloakModuleOptions } from './@types/package';
import { Keycloak } from 'keycloak-connect';
import { UMAConfiguration } from './@types/uma';
export declare class KeycloakService {
    private logger;
    private tokenSet?;
    private issuerClient?;
    private baseUrl;
    private requestManager;
    umaConfiguration?: UMAConfiguration;
    readonly options: KeycloakModuleOptions;
    connect: Keycloak;
    permissionManager: PermissionManager;
    resourceManager: ResourceManager;
    client: AdminClient;
    constructor(options: KeycloakModuleOptions);
    initialize(): Promise<void>;
    refreshGrant(): Promise<TokenSet | undefined | null>;
}
//# sourceMappingURL=service.d.ts.map