import { Scope } from './scope';
import { UMAResource, UMAScope } from '../@types/uma';
export declare class Resource {
    id?: string;
    displayName: string;
    name: string;
    uris?: string[];
    type?: string;
    owner?: string;
    ownerManagedAccess?: boolean;
    attributes?: Record<string, any>;
    scopes: Scope[];
    resourceScopes: Scope[];
    constructor(resource: UMAResource, scopes?: UMAScope[]);
    setId(id: string): Resource;
    setDisplayName(displayName: string): Resource;
    setName(name: string): Resource;
    setUris(uris: string[]): Resource;
    setType(type: string): Resource;
    setOwner(ownerId: string): Resource;
    setOwnerManagedAccess(isOwnerManaged: boolean): Resource;
    setAttributes(attributes: Record<string, any>): Resource;
    setScopes(scopes: Scope[]): Resource;
    setResourceScopes(scopes: Scope[]): Resource;
    isEqual(rhs: Resource): boolean;
    toJson(): UMAResource;
}
//# sourceMappingURL=resource.d.ts.map